#!/usr/bin/perl -w

use CGI::Carp qw(fatalsToBrowser);

# (C) Copyright 1999 by Calocybe Creations
# No legal restrictions needed for this tiny piece of code, so use it as you want.

#$DATABASE_FILE = "quiz.db";
#$EMAIL_HISTORY = "quiz.hist";

$DATABASE_FILE = "/home/atomic/public_html/selfspezial/quiz_2001/quiz.db";
$EMAIL_HISTORY = "/home/atomic/public_html/selfspezial/quiz_2001/quiz.hist";
$HeaderFile = "/home/atomic/public_html/selfspezial/quiz_2001/header";
$FooterFile = "/home/atomic/public_html/selfspezial/quiz_2001/footer";

#$DATABASE_FILE = "D:\\www\\selfspezial\\quiz_2001\\quiz.db";
#$EMAIL_HISTORY = "D:\\www\\selfspezial\\quiz_2001\\quiz.hist";
#$HeaderFile = "D:\\www\\selfspezial\\quiz_2001\\header";
#$FooterFile = "D:\\www\\selfspezial\\quiz_2001\\footer";

$DEADLINE =  1008975600; #1008975600 (22);  # 1008975600 == 21.12.2001 23:00 GMT == 22.12.1999 00:00 MET
# um andere Zeiten einzustellen: Von der Kommandozeile:
#   perl -e "print scalar gmtime 1008889200"         fuer GMT oder
#   perl -e "print scalar localtime 1008975600"      fuer eigene Zeitzone
# rumprobieren, bis man den richtigen Wert gefunden hat (die Zahl ist Sekunden seit 1970)



### Determine if we are running within an HTTP environment or started from an interactive shell.
###

$CGI_MODE = defined($ENV{'SERVER_NAME'});

###### PrintContentType([$type])
#
#   Prints the Content-Type header. $type specifies the mime type to be printed. If omitted, "text/plain" is assumed.
#   This is enclosed in a block in order to make $content_type_printed a static variable that is known nowhere else.
#

{
    my $content_type_printed = 0;

    sub PrintContentType {
        my $type;

        defined($type = shift) || ($type = "text/plain");

        if ($CGI_MODE && !$content_type_printed) {
            print "Content-Type: $type\n\n";
            $content_type_printed = 1;
        }
    }
}




###### vorbei()
#
#   Wird gecallt, wenn die Deadline uebeschritten ist.
#

sub vorbei() {
    PrintContentType("text/html");

    &htmlheader;

    print "<p>Zu sp&auml;t! Schade!</p>\n";

    &htmlfoot;

}




###### pflichtfelder_ausfuellen()
#
#   Wird gecallt wenn nicht alle Pflichtfelder ausgefuellt sind.
#

sub pflichtfelder_ausfuellen() {
    PrintContentType("text/html");
    &htmlheader;

    print "<p>Die Pflichtfelder m&uuml;ssen ausgef&uuml;llt werden - wo soll denn sonst der Preis hingeschickt werden, Dummerchen!</p>\n";

    &htmlfoot;
}




###### spinnst_wohl()
#
#   Wird gecallt wenn so einer versucht, zweimal zu quizzen.
#

sub spinnst_wohl() {
    PrintContentType("text/html");
    &htmlheader;

    print "<p>Willst Du zweimal gewinnen, oder was? Geht's?</p>\n";

    &htmlfoot;
}




###### komischer_fehler()
#
#   Wird gecallt wenn irgendwas nicht ging, z.B. Datei liess sich nicht oeffnen, oder so ein Bockmist.
#

sub komischer_fehler() {
    PrintContentType("text/html");
    &htmlheader;

    print "<p>Holy Shit! Sriptfehler in allen Modulen! Kernel Panic! AAAAArgh!</p>\n";

    &htmlfoot;
}




###### alles_klar()
#
#   Wird gecallt wenn alles klarging, d.h. Antworten sind gespeichert.
#

sub alles_klar() {
    PrintContentType("text/html");
    &htmlheader;

    print "<p>Danke f&uuml;rs mitmachen. Ihr Ergebnis wurde gespeichert. Bitte auflegen ;-)</p>\n";

    &htmlfoot;
}

sub htmlheader
{
	if ($HeaderFile)
	{
		open (HEADER, "$HeaderFile") || print "Can\'t open $HeaderFile $!\n";
		@Headery = <HEADER>;
		close (HEADER);
		foreach $Headery (@Headery)
		{
			print "$Headery";
		}
	}

	# print "</body></html>\n";
}

sub htmlfoot
{
	if ($FooterFile)
	{
		open (FOOTER, "$FooterFile") || print "Can\'t open $FooterFile $!\n";
		@Footery = <FOOTER>;
		close (FOOTER);
		foreach $Footery (@Footery)
		{
			print "$Footery";
		}
	}

	# print "</body></html>\n";
}


###### ReadFormData(\%form, $translate)
#
#   Parses the form data passed to the script, regardless whether GET or POST method is used, and stores the
#   argument=value pairs into the hash %form (pass a reference to that thing).
#   If $translate is true, any DOS or Mac newlines (CRLF or CR, respectively) are translated to normal newlines
#   as used on UNIX boxes (LF).
#   Returns 1 on success, 0 otherwise.
#

sub ReadFormData($$) {
    my ($formhash, $translate) = (shift, shift);
    my $data;
    my ($arg, $value);


    if ($CGI_MODE) {
        return 0 unless($ENV{'REQUEST_METHOD'});

        if ($ENV{'REQUEST_METHOD'} eq 'GET') {
            $data = $ENV{'QUERY_STRING'};
        } elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
            read(STDIN, $data, $ENV{'CONTENT_LENGTH'});
        } else {
            return 0;
        }
    } else {
        $data = join('&', @ARGV);
    }

    for (split(/&/, $data)) {
        ($arg, $value) = split(/=/);
        $value =~ tr/+/ /;
        $value =~ s/%([0-9A-Fa-f]{2})/chr(hex($1))/ge;
        if ($translate) {
            $value =~ s/\r\n/\n/g;
            $value =~ s/\r/\n/g;
        }
        $$formhash{$arg} = $value;
    }

    return 1;
}




###### nur_einmal($email)
#
#   Schaut nach, ob mit der email schon mal gequizzt wurde. Returns 1 falls noch nicht (darf also noch)
#   und 0 falls doch (darf also nicht mehr). Merkt sich die Adresse damit beim naechsten Mal 0 zurueckkommt.
#   Returns -1 falls irgenwas schiefging.
#

sub nur_einmal($) {
    my $email = shift;
    my @emails;
    local *EH;

    open(EH, ">$EMAIL_HISTORY"), close(EH) unless (-e $EMAIL_HISTORY);

    open(EH, "<$EMAIL_HISTORY") || return -1;
    @emails = <EH>;
    close(EH);

    (chomp, lc eq lc($email)) && return 0 for (@emails);

    open(EH, ">>$EMAIL_HISTORY") || return -1;
    print EH $email, "\n";
    close(EH);

    return 1;
}




###### merk_das_zeug(\%FormData)
#
#   Returns 0 falls irgendwas schiefging, 1 otherwise.
#

sub merk_das_zeug($) {
    my $form = shift;
    my $key;
    local *DB;

    open(DB, ">>$DATABASE_FILE") || return 0;
    print DB "$_=$form->{$_}\n" for (keys %$form);
    print DB ".\n";
    close(DB);

    return 1;
}


###### main()
#
#

sub main() {
    my %FormData;
    my $err;


    # erstmal gucken, ob die Zeit schon rum is
    (time() > $DEADLINE) and vorbei(), return;

    # was hatter uns denn so alles mitgeschickt?
    ReadFormData(\%FormData, 1);

    # gucken ob pflichtfelder passen
    pflichtfelder_ausfuellen(), return unless ($FormData{'name'} &&
        ($FormData{'email'} =~ /[\w\.-]+\@[\w\.-]+/) &&
        ($FormData{'PLZ'} =~ /^\d+$/) && $FormData{'Ort'} && $FormData{'Strasse'});

    # gucken ob schon mal gequizzt
    $err = nur_einmal($FormData{'email'});
    ($err ==  0) and spinnst_wohl(), return;
    ($err == -1) and komischer_fehler(), return;

    # geistige Erguesse merken
    merk_das_zeug(\%FormData) or komischer_fehler, return;

    # alles klar sagen
    alles_klar();
}

# jezz geht's los!
main();



